
; Multiplies the float pushed by -2 (fast way to get initial Newton-Raphson
; estimate for division).
fmul_m2: 
            ldd  2,SP
            lsla
            rolb
            inca
            eorb #1
            lsrb
            rora
            std  2,SP
            rts

; 0: X0, 4: D
fdiv_x1:
			leax 2,SP
			leas -8,SP
			movw 0,X,0,SP
			movw 2,X,2,SP
			movw 4,X,4,SP
			movw 6,X,6,SP
			jsr  fmul			; D*X0
			jsr  fnegate		; -D*X0
			movw #$4000,4,SP
			movw #$0000,6,SP
			jsr  fadd			; 2 - D*X0
			movw 0,X,4,SP
			movw 2,X,6,SP
			jsr  fmul			; X0 * (2 - D*X0)
			movw 0,SP,0,X
			movw 2,SP,2,X
			leas 8,SP
			rts
			
; 0: D	
fdiv_x0:
			leax 2,SP
			leas -4,SP
			movw 0,X,0,SP
			movw 2,X,2,SP
			bsr  fmul_m2		; -2*D
			leas -4,SP
			movw #$403a,0,SP
			movw #$8241,2,SP
			jsr  fadd			; 2.9142 - 2*D
			leas 8,SP
			rts

; Scales the dividend and divisor, which are pushed to the stack as arguments.
; 0: D, 4: Q
fdiv_scale:
            leax 2,SP            ; Set X to point to first argument
            leas -1,SP           ; Set SP to allow for 1 temp variable
            ldd  0,X             ; Get divisor[31:16]
            lsld                 ; Shift exp into A
            rolb                 ; Shift sign bit into B[0]
            suba #126            ; exp = exp - 126
            staa 0,SP            ; store in temp space
            ldaa #126            ; exp = 126
            lsrb                 ; shift sign bit out of B[0]
            rord                 ; shift sign bit into A[7]
            std  0,X             ; Store new exp  
            ldd  4,X             ; Get divisor[15:0]
            lsld                 ; Shift exp into A
            rolb                 ; Shift sign bit into B[0]
            suba 0,SP            ; exp_dividend = exp_dividend - (exp_divisor - 126)
            lsrb                 ; Shift sign bit out of B[0]
            rord                 ; Shift sign bit into A[7]
            std  4,X             ; Store new exp.
            leas 1,SP            ; Reset SP to proper place
            rts                  ; return


; 0: D, 4: Q			
fdiv:		leax 2,SP
			leas -9,SP
			movw 0,X,0,SP		; 0: D
			movw 2,X,2,SP
			movw 4,X,4,SP		; 4: Q
			movw 6,X,6,SP
			movb #4,8,SP		; 4 iterations are needed for 32 bits
			bsr  fdiv_scale		; copy D and Q and scale them
			
			leax 0,SP
			leas -4,SP
			movw 0,X,0,SP		; 0: D
			movw 2,X,2,SP
			bsr  fdiv_x0		; D: X0 = 2.9142 - 2*D
			
do_iters:	movw 0,X,4,SP		; 4: D
			movw 2,X,6,SP
			bsr  fdiv_x1		; X1 = X0 * (2 - D*X0)
			dbne 8,SP,do_iters

do_mult:	movw 4,X,4,SP
			movw 6,X,6,SP
			jsr  fmul			; should return quotient
			leax 15,SP
			movw 0,SP,0,X
			movw 2,SP,2,X
			leas 13,SP
			rts

